local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local c = BittensSpellFlashLibrary

local CR_CRIT_SPELL = CR_CRIT_SPELL
local GetCombatRating = GetCombatRating
local GetSpellBonusDamage = GetSpellBonusDamage
local GetSpellCritChance = GetSpellCritChance
local GetTime = GetTime
local MAX_POWER_PER_EMBER = MAX_POWER_PER_EMBER
local GetMastery = GetMastery
local SPELL_POWER_BURNING_EMBERS = SPELL_POWER_BURNING_EMBERS
local SPELL_POWER_DEMONIC_FURY = SPELL_POWER_DEMONIC_FURY
local SPELL_POWER_SOUL_SHARDS = SPELL_POWER_SOUL_SHARDS
local UnitPower = UnitPower
local math = math
local select = select

a.Rotations = {}
c.RegisterForEvents(a)
a.SetSpamFunction(function()
	c.Flash(a)
end)

local function flashSummon(...)
	if c.HasTalent("Grimoire of Sacrifice") then
		if not c.SelfBuffNeeded("Grimoire of Sacrifice") then
			return
		end
		
		if x.PetAlive then
			s.Flash(c.GetID("Grimoire of Sacrifice"), "yellow")
			return
		end
	elseif x.PetAlive then
		return
	end
	
--	local current = a.GetCurrentPet()
--	for i = 1, select("#", ...) do
--		if select(i, ...) == current then
--			return
--		end
--	end
	
	s.Flash(c.GetID("Summon Demon"), "yellow")
	for i = 1, select("#", ...) do
		s.Flash(c.GetID("Summon " .. select(i, ...)), "yellow")
	end
end

-------------------------------------------------------------------- Affliction
local socEmpowered = false
a.SoCEmpowered = false
a.SoCExplodeTime = 0
a.Snapshots = {
	["Agony"] = {
		Tick = 2,
		Dps = 0,
		Base = 274,
		Coeff = .26,
	},
	["Corruption"] = {
		Tick = 2,
		Dps = 0,
		Base = 214,
		Coeff = .2,
	},
	["Unstable Affliction"] = {
		Tick = 2,
		Dps = 0,
		Base = 252,
		Coeff = .24,
	},
}

function a.GetDps(name)
	local critMultiplier = 2
	local snap = a.Snapshots[name]
	local tick = c.GetHastedTime(2)
	return (snap.Base + snap.Coeff * GetSpellBonusDamage(6)) 
			* (1 + 3.1 * GetMastery() / 100)
			* (1 + (critMultiplier - 1) * GetSpellCritChance(6) / 100) 
			/ tick,
		tick
end

local function recordSnapshot(name)
	local snap = a.Snapshots[name]
	snap.Dps, snap.Tick = a.GetDps(name)
	c.Debug("Event", name, "applied at", snap.Dps, "dps")
end

a.Rotations.Afliction = {
	Spec = 1,
	OffSwitch = "affliction_off",
	
	FlashInCombat = function()
		a.Shards = s.Power("player", SPELL_POWER_SOUL_SHARDS)
		if c.IsQueued("Soulburn", "Haunt") or c.IsCasting("Haunt") then
			a.Shards = a.Shards - 1
		end
		
		if c.IsQueued("Seed of Corruption") then
			a.SoCEmpowered = c.HasBuff("Soulburn") or c.IsQueued("Soulburn")
		else
			a.SoCEmpowered = socEmpowered
		end
		
		c.FlashAll(
			"Curse of the Elements",
			"Dark Soul: Misery",
			"Grimoire: Felhunter",
			"Spell Lock",
			"Optical Blast",
			"Command Spell Lock")
		if s.HealthPercent() <= 20 then
--c.Debug("Flash", a.Shards, a.SoCEmpowered, GetTime() - a.SoCExplodeTime, 
			c.PriorityFlash(
				"Soulburn during Execute",
				"Haunt during Execute",
				"Soul Swap during Execute",
				"Life Tap for Affliction",
				"Drain Soul")
--)
		else
--c.Debug("Flash", a.Shards, a.SoCEmpowered, GetTime() - a.SoCExplodeTime, 
			c.PriorityFlash(
				"Soulburn under Dark Soul: Misery",
				"Agony within GCD",
				"Haunt",
				"Corruption within GCD",
				"Unstable Affliction within GCD",
				"Agony with Pandemic",
				"Unstable Affliction with Pandemic",
				"Corruption with Pandemic",
				"Agony Soon",
				"Unstable Affliction Soon",
				"Corruption Soon",
				"Life Tap for Affliction",
				"Agony before Malefic Grasp",
				"Malefic Grasp")
--)
		end
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Soul Swap under Soulburn", 
			"Dark Intent", 
			"Soulstone", 
			"Dark Regeneration",
			"Underwater Breath")
		flashSummon("Felhunter", "Observer")
	end,
	
--	CastQueued = function(info)
--		if c.InfoMatches(info, "Corruption") then
--c.Debug("Corruption", "Queued", c.GetMyDebuffDuration("Corruption"), c.GetMyDebuffDuration("Corruption") / c.GetSpell("Corruption Soon").EarlyRefresh)
--		end
--	end,
	
	CastStarted = function(info)
		if c.InfoMatches(info, "Seed of Corruption") then
			socEmpowered = c.HasBuff("Soulburn") --or c.IsQueued("Soulburn")
			c.Debug("Event", "Seed of Corruption start", socEmpowered)
		end
	end,
	
	CastFailed = function(info, quiet)
		if not quiet and c.InfoMatches(info, "Seed of Corruption") then
			socEmpowered = false
			c.Debug("Event", "Seed of Corruption Failed")
		end
	end,
	
--	CastSucceeded = function(info)
--		if c.InfoMatches(info, "Soulburn") then
--			a.SoulburnedDuringMisery = s.Buff(
--				c.GetID("Dark Soul: Misery"), "player")
--			c.Debug(
--				"Event", "Soulburned during Misery:", a.SoulburnedDuringMisery)
--		elseif c.InfoMatches(info, "Dark Soul: Misery") then
--			a.SoulburnedDuringMisery = false
--			c.Debug("Event", "Misery Cast")
--		else
--if c.InfoMatches(info, "Corruption") then
--c.Debug("Corruption", "Succeeded", c.GetMyDebuffDuration("Corruption"), c.GetMyDebuffDuration("Corruption") / c.GetSpell("Corruption Soon").EarlyRefresh)
--end
--	end,
	
	AuraApplied = function(spellID)
		
		-- Do this here instead of c.ManageDotRefresh so that it updates when
		-- cast via Soul Swap
		if spellID == c.GetID("Agony") then
			recordSnapshot("Agony")
		elseif spellID == c.GetID("Corruption") then
			recordSnapshot("Corruption")
--c.Debug("Corruption", "Applied", c.GetMyDebuffDuration("Corruption"), c.GetMyDebuffDuration("Corruption") / tick)
		elseif spellID == c.GetID("Unstable Affliction") then
			recordSnapshot("Unstable Affliction")
		end
	end,
	
	AuraRemoved = function(spellID)
		if spellID == c.GetID("Seed of Corruption") then
			c.Debug("Event", "SoC Explode", socEmpowered)
			if socEmpowered then
				a.SoCExplodeTime = GetTime()
				socEmpowered = false
			end
		end
	end,
}

-------------------------------------------------------------------- Demonology
a.Rotations.Demonology = {
	Spec = 2,
	OffSwitch = "demonology_off",
	
	FlashInCombat = function()
		a.Fury = s.Power("player", SPELL_POWER_DEMONIC_FURY)
		a.Morphed = s.Form(c.GetID("Metamorphosis"))
		c.FlashAll(
			"Curse of the Elements",
			"Dark Soul: Knowledge",
			"Felstorm",
			"Wrathstorm",
			"Grimoire: Felguard",
			"Axe Toss",
			"Super Axe Toss")
c.Debug("Flash", a.Fury, 
		c.PriorityFlash(
			"Corruption for Demonology",
			"Doom",
			"Metamorphosis",
			"Metamorphosis Cancel",
			"Hand of Gul'dan",
			"Touch of Chaos for Corruption",
			"Soul Fire",
			"Touch of Chaos",
			"Life Tap under 50",
			"Shadow Bolt")
)
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Dark Intent", 
			"Soulstone", 
			"Dark Regeneration",
			"Underwater Breath")
		flashSummon("Felguard", "Wrathguard")
	end,
	
	CastSucceeded = function(info)
		if c.InfoMatches(info, "Doom") then
			a.DoomIsBuffed = c.HasBuff("Dark Soul: Knowledge")
			c.Debug("Event", "Doom is buffed:", a.DoomIsBuffed)
		end
	end,
	
	LeftCombat = function()
		a.DoomIsBuffed = false
		c.Debug("Event", "Left combat")
	end,
}

------------------------------------------------------------------- Destruction
local lastEmbers = nil
local pendingEmberBump = 0
local pendingEmberDrop = false

a.Rotations.Destruction = {
	Spec = 3,
	OffSwitch = "destro_off",
	
	FlashInCombat = function()
		a.Embers = UnitPower("player", SPELL_POWER_BURNING_EMBERS, true) 
			/ MAX_POWER_PER_EMBER
		if lastEmbers ~= nil then
			if a.Embers > lastEmbers then
				pendingEmberBump = math.max(
					0, pendingEmberBump - (a.Embers - lastEmbers))
				c.Debug("Flash", "Ember bump occurred")
			elseif a.Embers < lastEmbers then
				pendingEmberDrop = false
				c.Debug("Flash", "Ember drop occurred")
			end
		end
		lastEmbers = a.Embers
		a.Embers = a.Embers + pendingEmberBump
		if pendingEmberDrop then
			a.Embers = a.Embers - 1
		end
		
		if c.IsCasting("Incinerate") or c.IsCasting("Conflagrate") then
			a.Embers = a.Embers + .1
		elseif c.IsCasting("Chaos Bolt") 
			or c.IsCasting("Shadowburn") 
			or c.IsCasting("Fire and Brimstone") then
			
			a.Embers = a.Embers - 1
		end
		
		a.Backdraft = c.GetBuffStack("Backdraft")
		if a.Backdraft > 0 and c.IsCasting("Incinerate") then
			a.Backdraft = a.Backdraft - 1
		elseif c.IsCasting("Conflagrate") then
			a.Backdraft = 3
		end
		
		
		c.FlashAll(
			"Curse of the Elements",
			"Dark Soul: Instability",
			"Grimoire: Felhunter",
			"Ember Tap",
			"Spell Lock",
			"Optical Blast",
			"Command Spell Lock")
		if c.AoE then
			local flashing = c.PriorityFlash(
				"Immolate",
				"Rain of Fire",
				"Conflagrate",
				"Incinerate")
			if flashing == "Immolate" 
				or (a.Embers >= 2 and flashing == "Incinerate") then
				
				c.PriorityFlash("Fire and Brimstone")
			end
		else
c.Debug("Flash", a.Embers, a.Backdraft, pendingEmberBump, pendingEmberDrop,
			c.PriorityFlash(
				"Shadowburn",
				"Immolate",
				"Chaos Bolt",
				"Conflagrate",
				"Incinerate")
)
		end
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Dark Intent", 
			"Soulstone", 
			"Dark Regeneration",
			"Underwater Breath")
		flashSummon("Felhunter", "Observer")
	end,
	
--CastQueued = function(info)
--c.Debug("Event", "Queued", info.Name)
--end,
	
	CastSucceeded = function(info)
		if c.InfoMatches(
			info, 
			"Incinerate", 
			"Conflagrate", 
			"Incinerate AoE", 
			"Conflagrate AoE") then
			
			pendingEmberBump = pendingEmberBump + .1
			c.Debug("Event", "Ember bump pending:", info.Name)
		elseif c.InfoMatches(
			info, "Chaos Bolt", "Shadowburn", "Fire and Brimstone") then
			
			pendingEmberDrop = true
			c.Debug("Event", "Ember drop pending:", info.Name)
		end
	end,
	
	SpellDamage = function(spellID, target, amount, critical)
--c.Debug("Event", "Damage:", spellID, s.SpellName(spellID), target, amount, critical)
		if critical 
			and (spellID == c.GetID("Incinerate")
				or spellID == c.GetID("Conflagrate")
				or spellID == c.GetID("Immolate")
				or spellID == c.GetID("Incinerate AoE")
				or spellID == c.GetID("Conflagrate AoE")
				or spellID == c.GetID("Immolate AoE")) then
			
			pendingEmberBump = pendingEmberBump + .1
			c.Debug("Event", "Ember bump pending from crit")
		end
	end,
	
	LeftCombat = function()
		lastEmbers = nil
		pendingEmberBump = 0
		pendingEmberDrop = false
		c.Debug("Event", "Left combat")
	end,
}
